<?php

	class bitpay
	{
		public function __construct()
		{
			$this->network = &$GLOBALS['network'];
			$this->user = &$GLOBALS['user'];
			$this->db2 = &$GLOBALS['db2'];
		}
		public function request($Price, $uid = "", $ReturnPath = "", $Description = "",	$Mobile = "", $Email = "", $username = "")
		{
			global $C;
			require_once ($C->INCPATH . 'config/balance.php');
			$Price = $this->db2->e($Price); //Price by Toman
			$rial = $Price.'0'; // Price by Rial
			if ($Price < $C->MIN_PAY) {
				return "err1";
			}
			$ResNumber = "DBLNC" . time() . rand(10000, 99999); // Order Id In Your System
			$ReturnPath = (empty($ReturnPath)) ? $C->SITE_URL . "settings/ewallet/" : $ReturnPath;
			$Description = (empty($Description)) ? 'افزایش اعتبار حساب کاربری' : $Description;
			$Paymenter = (empty($username)) ? $this->user->info->username : $username;
			$Email = (empty($Email)) ? $this->user->info->email : $Email;
			$Mobile = (empty($Mobile)) ? $this->user->info->numobile : $Mobile;
			$status = 0;
			$result = $this->send('https://bitpay.ir/payment/gateway-send', $C->bitpayMerchant, $rial, $ReturnPath); 
			if($result > 0 && is_numeric($result)){
				$PayPath = "https://bitpay.ir/payment/gateway-".$result;
				$status = 100;
			}
			if ($status == 100) {
				$shop_date = time();
				$uid = (empty($uid)) ? intval($this->user->id) : $uid;
				$this->db2->query("INSERT INTO `user_payments` (`uid`,`price`,`invoice_number`,`refid`,`date`,`mob`,`mail`)VALUES('$uid','$Price','$ResNumber','$result','$shop_date','$Mobile','$Email');");
				return "پرداخت : $Price تومان <br/> شناسه پرداخت : $ResNumber <br/>شناسه‌ی پرداخت را تا پایان خرید و شارژ حساب نگهداری نمایید!<br/> برای ورود به درگاه پی‌‎لاین بر روی دکمه پرداخت کلیک نمایید.<br><br><a id='signin_submit' href='$PayPath' name='cancel' >پرداخت</a><a id='tw_submit' onclick='form()' name='cancel' >بازگشت</a><br><br>";
			} else {
				return "err2"; 
			}
		}
		
		function send($url, $api, $amount, $redirect){
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,$url);
			curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
			$res = curl_exec($ch);
			curl_close($ch);
			return $res;
		}
		
		function get($url, $api, $trans_id, $id_get){
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,$url);
			curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
			$res = curl_exec($ch);
			curl_close($ch);
			return $res;
}  
		
		public function verify($resnum, $refnumber)
		{
			global $C;
			require_once ($C->INCPATH . 'config/balance.php');
			$refid = 0;
			$result = $this->get('https://bitpay.ir/payment/gateway-result-second', $C->bitpayMerchant, $resnum, $refnumber); 
			if($result > 0 && is_numeric($result)){
				$refid = 100;
			}
			if ($refid == 100) {
				$response = array("status" => "success", "refid" => $refnumber);
				return $response;
			} else {
				return false;
			}
		}
	}
